Class gestureInter extends Interaction;

var bool cursorClick; //rmouse held, reads from player controller variable
var bool cursorDraw; //lmouse held, reads from player controller variable
var texture cursorHold,  cursorUp; //2 cursors, one for normal, one for clicking

//***variables for spawning effect when hand draws on screen
var float CursorX, CursorY; //cursor position on screen
var vector spawnTemp, spawnTo, playerCamLoc, offset; //temp vector for ScreenToWorld, spawnTo for final location
var rotator playerRotation; //just what it sounds like
var gestureProjEffect gEffect; //spawning effect actor

Function Initialize()
{
	cursorClick = grabinController(ViewportOwner.Actor).cClick;
	cursorDraw = grabinController(ViewportOwner.Actor).cDraw;
	offset.Z = 50;
	//click and draw initialised to controller values. offset of draw effect declared
}

event Initialized()
{

}

function drawing()
{
	CursorX = ViewportOwner.Actor.Player.WindowsMouseX;
   	CursorY = ViewportOwner.Actor.Player.WindowsMouseY;
   	playerRotation = ViewportOwner.Actor.Rotation;
   	spawnTemp.X = CursorX;
   	spawnTemp.Y = CursorY;
   		//vector to spawn effect to in relation to camera
   	spawnTo = ScreenToWorld(spawnTemp,playerCamLoc + offset,);
   		//spawn effect at world center (effect should have warmup time)
   	gEffect = ViewportOwner.Actor.spawn(Class 'gestureProjEffect',,,spawnTo,);
   		//move effect to absolute coords
   	gEffect.Move(gEffect.Location + playerCamLoc);
}

function PostRender(Canvas C)
{
   cursorClick = grabinController(ViewportOwner.Actor).cClick;
   cursorDraw = grabinController(ViewportOwner.Actor).cDraw;
   	//each pass, detect if Rmouse or Lmouse clicked
   
   if(cursorClick==true)
   {
	CursorX = ViewportOwner.Actor.Player.WindowsMouseX;
   	CursorY = ViewportOwner.Actor.Player.WindowsMouseY;

   	//CURSOR
   	c.SetDrawColor(255, 255, 255);
   	c.Style = 6;
   	C.SetPos( CursorX, CursorY );
   	c.DrawIcon(cursorHold, 1/2);

   	/*if(cursorclick==true)
   	{
   		c.DrawIcon(cursorHold, 1/2);
   	}
   	if(cursorclick!=true)
   	{
   		C.DrawIcon(cursorUp, 1/2);
   	}*/
   }
   if (cursorDraw)
   {
   	playerCamLoc = ViewportOwner.Actor.Pawn.Location + ViewportOwner.Actor.Pawn.EyePosition();
   		//set location of player cam before function execution
   	drawing();
   		//draw effect onscreen
   }
}

function bool KeyEvent(EInputKey Key, EInputAction Action, FLOAT Delta )
{
	//local float halfX, halfY;
	//local grabinHUD grabinHUD;
	
		//all very self explanatory, if buttons clicked, change variables.
	if ((Action == IST_Press) && (Key == IK_RightMouse))
	{
		grabinController(ViewportOwner.Actor).setClick(true);
	}

	if ((Action == IST_Release) && (Key == IK_RightMouse))
	{
		grabinController(ViewportOwner.Actor).setClick(false);
		grabinController(ViewportOwner.Actor).setDraw(false);
	}
	if ((Action == IST_Press) && (Key == IK_LeftMouse) && cursorClick)
	{
		grabinController(ViewportOwner.Actor).setDraw(true);
	}

	if ((Action == IST_Release) && (Key == IK_LeftMouse))
	{
		grabinController(ViewportOwner.Actor).setDraw(false);
	}
	return false;
}


event NotifyLevelChange()
{	
        	//kill interaction on level change to stop crashes
        Master.RemoveInteraction(self);
}

defaultProperties
{
	cursorHold=Texture'Crosshairs.HUD.Crosshair_Triad3'
	cursorUp=Texture'Crosshairs.HUD.Crosshair_Triad2'
	bActive=True
	bVisible=True
	//bRequiresTick=True	
}