Class grabinController extends xPlayer;

var bool bHasInteraction;
var bool cClick; //if Rmouse is held
var bool cDraw; //if Lmouse is held

function setClick(bool in)
{
	cClick = in;
	//return true;
}

function setDraw(bool in)
{
	cDraw = in;
	//return true;
}

auto state PlayerWaiting
{
//ignores SeePlayer, HearNoise, NotifyBump, TakeDamage, PhysicsVolumeChange, NextWeapon, PrevWeapon, SwitchToBestWeapon;

	Begin:
    	If ((Viewport(Player) != None) && (!bHasInteraction))
        {
        	Player.InteractionMaster.AddInteraction("halfGrabin.gestureInter", Player);
        	bHasInteraction = True;
        }
}

function UpdateRotation(float DeltaTime, float maxPitch)
{
    local rotator newRotation, ViewRotation;
	
	if (cClick == false)
	{
		if ( bInterpolating || ((Pawn != None) && Pawn.bInterpolating) )
    		{
        		ViewShake(deltaTime);
        		return;
		}

    		// Added FreeCam control for better view control
    		if (bFreeCam == True)
    		{
        		if (bFreeCamZoom == True)
        		{
            			CameraDeltaRad += DeltaTime * 0.25 * aLookUp;
        		}
        		else if (bFreeCamSwivel == True)
        		{
            			CameraSwivel.Yaw += 16.0 * DeltaTime * aTurn;
            			CameraSwivel.Pitch += 16.0 * DeltaTime * aLookUp;
        		}
        		else
        		{
            			CameraDeltaRotation.Yaw += 32.0 * DeltaTime * aTurn;
            			CameraDeltaRotation.Pitch += 32.0 * DeltaTime * aLookUp;
        		}
    		}
    		else
    		{
        		ViewRotation = Rotation;

			if(Pawn != None && Pawn.Physics != PHYS_Flying) // mmmmm
			{
				// Ensure we are not setting the pawn to a rotation beyond its desired
				if(	Pawn.DesiredRotation.Roll < 65535 &&
				(ViewRotation.Roll < Pawn.DesiredRotation.Roll || ViewRotation.Roll > 0))
					ViewRotation.Roll = 0;
				else if( Pawn.DesiredRotation.Roll > 0 &&
				(ViewRotation.Roll > Pawn.DesiredRotation.Roll || ViewRotation.Roll < 65535))
					ViewRotation.Roll = 0;
			}

        		DesiredRotation = ViewRotation; //save old rotation

        		if ( bTurnToNearest != 0 )
            			TurnTowardNearestEnemy();
        		else if ( bTurn180 != 0 )
            			TurnAround();
        		else
        		{
            			TurnTarget = None;
            			bRotateToDesired = false;
            			bSetTurnRot = false;
            			ViewRotation.Yaw += 32.0 * DeltaTime * aTurn;
            			ViewRotation.Pitch += 32.0 * DeltaTime * aLookUp;
        		}
        		ViewRotation.Pitch = LimitPitch(ViewRotation.Pitch); //amb

        		SetRotation(ViewRotation);

        		ViewShake(deltaTime);
        		ViewFlash(deltaTime);

        		NewRotation = ViewRotation;
        		//NewRotation.Roll = Rotation.Roll;

        		if ( !bRotateToDesired && (Pawn != None) && (!bFreeCamera || !bBehindView) )
           			Pawn.FaceRotation(NewRotation, deltatime);
           	}
        }
}

defaultproperties
{
	cClick=False
	cDraw=False
}